SymmetricCipher Class Reference

Interface for one direction (encryption or decryption) of a stream cipher or cipher mode. More...

`#include <cryptlib.h>`

Inheritance diagram for SymmetricCipher:

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length.
virtual size_t | DefaultKeyLength () const =0
| Returns default key length.
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm.
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object.
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size.
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| Encrypt or decrypt an array of bytes.
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data.
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block.
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing.
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes.
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes.
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte.
virtual bool | IsRandomAccess () const =0
| Determines whether the cipher supports random access.
virtual void | Seek (lword pos)
| Seek to an absolute position.
virtual bool | IsSelfInverting () const =0
| Determines whether the cipher is self-inverting.
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Detailed Description

Interface for one direction (encryption or decryption) of a stream cipher or cipher mode.

These objects usually should not be used directly. See StreamTransformation for more details.

Definition at line 1295 of file cryptlib.h.

The documentation for this class was generated from the following file:

- cryptlib.h